program Maze1;
{	Sample file nr. 2 for KPascal.
	Maze using a simple DFS

	Copyright  2002, Konstantin Tretyakov
}

type 
	TMazeArray = array[0..24, 0..80] of Boolean;


procedure InitMaze(var A: TMazeArray); 
var i, j: Integer;
begin
	for i := 1 to 23 do
		for j := 1 to 79 do A[i,j] := True;
	for i := 0 to 24 do begin
		A[i, 0] := False;
		A[i, 80] := False;
	end;
	for j := 0 to 80 do begin
		A[0, j] := False;
		A[24, j] := False;
	end;
end;

procedure PrintMaze(var A: TMazeArray); {Pass as VAR for efficiency}
var i, j: Integer; S: String;
begin
	for i := 1 to 23 do begin
		S := '';
		for j := 1 to 79 do if A[i,j] = True then
			S := S + #219 {white square, use #2 for smileys}
		else S := S + ' ';
		WriteLn(S);
	end;
	WriteLn('');
end;

var 
	A: TMazeArray;

procedure WalkMaze(X, Y: Integer);
var i: Integer;
begin
	while A[X-2,Y] or A[X+2, Y] or A[X, Y-2] or A[X, Y+2] do begin
		i := Random(4);
		while i > -1 do begin
			if i = 0 then begin {Up}
				if A[X, Y-2] then begin
					i := -1;
					A[X, Y-1] := False;
					A[X, Y-2] := False;
					WalkMaze(X, Y-2);
				end else i := 1;
			end else if i = 1 then begin {Down}
				if A[X, Y+2] then begin
					i := -1;
					A[X, Y+1] := False;
					A[X, Y+2] := False;
					WalkMaze(X, Y+2);
				end else i := 2;
			end else if i = 2 then begin {Left}
				if A[X-2, Y] then begin
					i := -1;
					A[X-1, Y] := False;
					A[X-2, Y] := False;
					WalkMaze(X-2, Y);
				end else i := 3;
			end else if i = 3 then begin
				if A[X+2, Y] then begin {Right}
					i := -1;
					A[X+1, Y] := False;
					A[X+2, Y] := False;
					WalkMaze(X+2, Y);
				end else i := 0;
			end;{if}
		end;{while}
	end; {while}
end;

label Start;
var S: String;
begin
Start:
	WriteLn('Wait a sec...');
	InitMaze(A);
	A[2,2] := False;
	WalkMaze(2,2);
	PrintMaze(A);
	Write('Strike ENTER for more or enter N to quit:');
	ReadLn(S);
	if S = '' then goto Start;
end.
